local L = AceLibrary("AceLocale-2.2"):new("MobileVault")
local spacing = 100 + (25 / 6)

function MobileVault:CreateBottomBar()
	local f = CreateFrame("BUTTON", nil, MobileVault.anchor)
	f:SetWidth(725)
	f:SetHeight(25)
	
	f:SetPoint("TOP", MobileVault.anchor, "BOTTOM", 0, -315)
	
	f:SetBackdrop({
		bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	f:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, 1)
	
	f.scan = f:CreateFontString(nil, "OVERLAY")
	f.scan:SetFontObject(GameFontNormal)
	f.scan:ClearAllPoints()
	f.scan:SetTextColor(self.db.profile.Tred, self.db.profile.Tgreen, self.db.profile.Tblue, 1)
	f.scan:SetWidth(725)
	f.scan:SetHeight(20)
	f.scan:SetPoint("TOP", f, "TOP", 5, -1)
	f.scan:SetJustifyH("LEFT")
	f.scan:SetJustifyV("MIDDLE")
	f.scan:SetText(L["Last Scan:"].." ")
	
	f.gold = f:CreateFontString(nil, "OVERLAY")
	f.gold:SetFontObject(GameFontNormal)
	f.gold:ClearAllPoints()
	f.gold:SetTextColor(self.db.profile.Tred, self.db.profile.Tgreen, self.db.profile.Tblue, 1)
	f.gold:SetWidth(725)
	f.gold:SetHeight(20)
	f.gold:SetPoint("TOP", f, "TOP", -5, -2)
	f.gold:SetJustifyH("RIGHT")
	f.gold:SetJustifyV("MIDDLE")
	f.gold:SetText("xxxg  xxs xxc")
	
	f:Show()
	
	return f
end

function MobileVault:CreateSplashScreen(text)
	local f = CreateFrame("FRAME", nil, MobileVault.anchor)
	f:SetWidth(725)
	f:SetHeight(320)
	
	f:ClearAllPoints()
	f:SetPoint("TOP", MobileVault.anchor, "BOTTOM")
	
	f:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8X8]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
	
	f:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, 1)
	
	f.text = f:CreateFontString(nil, "OVERLAY")
	f.text:SetFontObject(SystemFont)
	f.text:ClearAllPoints()
	f.text:SetTextColor(self.db.profile.Tred, self.db.profile.Tgreen, self.db.profile.Tblue, 1)
	f.text:SetWidth(725)
	f.text:SetHeight(20)
	f.text:SetPoint("TOP", f, "TOP")
	f.text:SetJustifyH("CENTER")
	f.text:SetJustifyV("MIDDLE")
	f.text:SetText(text)
	
	f:Show()
	
	return f
end

function MobileVault:CreateAlertFrame()
	local f = CreateFrame("FRAME", nil, UIParent)
	f:SetWidth(300)
	f:SetHeight(100)
	
	f:ClearAllPoints()
	f:SetPoint("CENTER", UIParent, "CENTER", -200, 120)
	
	f:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8X8]],
		edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	
	f:SetBackdropColor(.5, .5, .5, 1)
	
	f.text = f:CreateFontString(nil, "OVERLAY")
	f.text:SetFontObject(SystemFont)
	f.text:ClearAllPoints()
	f.text:SetTextColor(1, 1, 1, 1)
	f.text:SetWidth(300)
	f.text:SetHeight(50)
	f.text:SetPoint("TOP", f, "TOP")
	f.text:SetJustifyH("CENTER")
	f.text:SetJustifyV("MIDDLE")
	f.text:SetText(L["Mobile Guild Vault Scan In Progress!"].."       "..L["Do not touch the Guild Bank"])
	f.text1 = f:CreateFontString(nil, "OVERLAY")
	f.text1:SetFontObject(SystemFont)
	f.text1:ClearAllPoints()
	f.text1:SetTextColor(1, 1, 1, 1)
	f.text1:SetWidth(300)
	f.text1:SetHeight(50)
	f.text1:SetPoint("BOTTOM", f, "BOTTOM")
	f.text1:SetJustifyH("CENTER")
	f.text1:SetJustifyV("MIDDLE")
	f.text1:SetText(L["Scan should finish in under 60 seconds"])
	
	f:SetFrameStrata("HIGH")
	
	f:Hide()
	
	return f
end

function MobileVault:CreateAnchor()
	local f = CreateFrame("BUTTON", nil, UIParent)
	
	f.close = CreateFrame("BUTTON", nil, f, "UIPanelCloseButton")
	f.close:SetPoint("TOPRIGHT", f, "TOPRIGHT", -2, -1)
	
	f:SetWidth(725)
	f:SetHeight(45)
	
	f:SetFrameStrata("LOW")
	f.owner = self
	
	if MobileVault.db.profile.position.x and MobileVault.db.profile.position.y and MobileVault.db.profile.position.anchor and MobileVault.db.profile.position.point then
		f:ClearAllPoints()
		f:SetPoint(MobileVault.db.profile.position.point, UIParent, MobileVault.db.profile.position.anchor, MobileVault.db.profile.position.x, MobileVault.db.profile.position.y)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 175)
	end
	
	f:SetBackdrop({
		bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	f:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, .7)
	
	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function ()
			this:StopMovingOrSizing()
			local point, _, anchor, x, y = this:GetPoint()
			this.owner.db.profile.position.x = math.floor(x)
			this.owner.db.profile.position.y = math.floor(y)
			this.owner.db.profile.position.anchor = anchor
			this.owner.db.profile.position.point = point
		end)
	f:SetScript("OnEnter", function()
		if not this:IsVisible() then return end
		GameTooltip:SetOwner(this)
		GameTooltip:ClearLines()
		GameTooltip:AddLine("|cffffffff" .. L["Left-click to drag the window"] .. "|r")
		GameTooltip:AddLine("|cffffffff" .. L["Right-click to open the DewDrop menu"] .. "|r")
		GameTooltip:Show()
	end)
	f:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	
	f:EnableMouse(true)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")
	f:SetClampedToScreen(true)
	
	f.text = f:CreateFontString(nil, "OVERLAY")
	f.text:SetFontObject(GameFontNormal)
	f.text:ClearAllPoints()
	f.text:SetTextColor(self.db.profile.Tred, self.db.profile.Tgreen, self.db.profile.Tblue, 1)
	f.text:SetWidth(725)
	f.text:SetHeight(20)
	f.text:SetPoint("TOP", f, "TOP")
	f.text:SetJustifyH("CENTER")
	f.text:SetJustifyV("MIDDLE")
	f.text:SetText(L["Mobile Guild Vault"])
	
	f.subtext = f:CreateFontString(nil, "OVERLAY")
	f.subtext:SetFontObject(GameFontNormal)
	f.subtext:ClearAllPoints()
	f.subtext:SetTextColor(self.db.profile.Tred, self.db.profile.Tgreen, self.db.profile.Tblue, 1)
	f.subtext:SetWidth(725)
	f.subtext:SetHeight(20)
	f.subtext:SetPoint("BOTTOM", f, "BOTTOM", 0, 2)
	f.subtext:SetJustifyH("CENTER")
	f.subtext:SetJustifyV("MIDDLE")
	
	f:Hide()
	
	return f
end

function MobileVault:CreateTabs()
	local storage = {}
	
	for i = 1, 6 do
		local a = CreateFrame("BUTTON", nil, MobileVault.anchor)
		a.tab = a:CreateTexture(nil, "BORDER")
		a.tab:SetWidth(30)
		a.tab:SetHeight(30)
		a.tab:SetTexCoord(0, 1, 0, 1)
		
		a:SetWidth(40)
		a:SetHeight(40)
		a:ClearAllPoints()
		a:SetPoint("LEFT", MobileVault.anchor, "RIGHT", 5, (-10 - ((i-1)*50)))
		a.tab:SetPoint("CENTER", a, "CENTER")
		
		a:SetBackdrop({
			bgFile = [[Interface\Buttons\WHITE8X8]],
			edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
			tile = false, tileSize = 16, edgeSize = 15,
			insets = { left = 5, right = 5, top = 5, bottom = 5 }
		})
		
		a:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, 1)
		a:SetBackdropBorderColor(self.db.profile.Bred, self.db.profile.Bgreen, self.db.profile.Bblue, 1)
		a:EnableMouse(true)
		a:RegisterForClicks("LeftButtonUp")
		
		a:SetScript("OnEnter", function()
			GameTooltip:SetOwner(this)
			GameTooltip:ClearLines()
			GameTooltip:AddLine("|cffffffff"..L["Page"].." "..i)
			GameTooltip:Show()
		
			a:SetBackdropBorderColor(self.db.profile.Hred, self.db.profile.Hgreen, self.db.profile.Hblue, 1)
		end)
		a:SetScript("OnLeave", function()
			GameTooltip:Hide()
			if a.clicked then
				a:SetBackdropBorderColor(self.db.profile.Cred, self.db.profile.Cgreen, self.db.profile.Cblue, 1)
			else
				a:SetBackdropBorderColor(self.db.profile.Bred, self.db.profile.Bgreen, self.db.profile.Bblue, 1)
			end
		end)
		a:SetScript("OnClick", function()
			if arg1 == "LeftButton" then
				for k, v in pairs(self.pages) do
					if k == self.activePage then
						self:TriggerEvent("MGV_PAGESWITCH", i)
						self.pages[k]:Hide()
						self.pages[i]:Show()
						self.tab_buttons[k].clicked = false
						self.tab_buttons[i].clicked = true
						self.tab_buttons[k]:SetBackdropBorderColor(self.db.profile.Bred, self.db.profile.Bgreen, self.db.profile.Bblue, 1)
						self.tab_buttons[i]:SetBackdropBorderColor(self.db.profile.Cred, self.db.profile.Cgreen, self.db.profile.Cblue, 1)
						self.activePage = i
					end
				end
			end
		end)
		
		a:Show()
		
		table.insert(storage, a)
	end
	
	return storage
end

function MobileVault:CreatePage(first)
	local f = CreateFrame("FRAME", nil, MobileVault.anchor)
	f:SetWidth(725)
	f:SetHeight(320)
	
	f:ClearAllPoints()
	f:SetPoint("TOP", MobileVault.anchor, "BOTTOM")
	
	f:SetBackdrop({
		bgFile = [[Interface\Buttons\WHITE8X8]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
	
	f:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, 1)
	f:EnableMouse(true)
	
	f.subframes = self:CreateSubFrames(f)
	
	if first then
		f:Show()
	else
		f:Hide()
	end
	
	return f
end

function MobileVault:CreateSubFrames(parent)
	local storage = {}
	for i = 1, 7 do
		local a = CreateFrame("FRAME", nil, parent)
		a:SetWidth(100)
		a:SetHeight(320)
		
		a:ClearAllPoints()
		if i == 1 then
			a:SetPoint("LEFT", parent, "LEFT")
		else
			a:SetPoint("LEFT", parent, "LEFT", (spacing * (i - 1)), 0)
		end
		
		a:SetBackdrop({
			bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
			edgeFile = nil,
			tile = false, tileSize = 16, edgeSize = 16,
			insets = { left = 5, right = 5, top = 5, bottom = 5 }
		})
		a:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, .65)
		a:EnableMouse(true)
	
		a.slots = self:CreateSlots(a)
	
		a:Show()
		
		table.insert(storage, a)
	end
	
	return storage
end

function MobileVault:CreateSlots(parent)
	local storage = {}
	for i = 1, 14 do
		local a = CreateFrame("BUTTON", nil, parent)
		a.item = a:CreateTexture(nil, "BORDER")
		a.item:SetWidth(32)
		a.item:SetHeight(32)
		
		a.count = a:CreateFontString(nil, "BORDER")
		a.count:SetWidth(32)
		a.count:SetHeight(32)
		a.count:SetFontObject(NumberFontNormalSmallGray)
		a.count:SetTextColor(1, 1, 1, 1)
		a.count:SetJustifyH("RIGHT")
		a.count:SetJustifyV("BOTTOM")
		
		a:SetWidth(40)
		a:SetHeight(40)
		
		a:ClearAllPoints()
		if i == 1 then
			a:SetPoint("TOPLEFT", parent, "TOPLEFT", 7, -7)
		elseif i > 1 and i <= 7 then
			a:SetPoint("TOPLEFT", parent, "TOPLEFT", 7, (-7 - ((i - 1) * 45)))
		elseif i == 8 then
			a:SetPoint("TOPLEFT", parent, "TOPLEFT", 52, -7)
		elseif i > 8 then
			a:SetPoint("TOPLEFT", parent, "TOPLEFT", 52, (-7 - ((i - 8) * 45)))
		end
		
		a:SetBackdrop({
		bgFile = [[Interface\Tooltips\UI-Tooltip-Background]],
		edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
		tile = false, tileSize = 16, edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		
		a:SetBackdropColor(self.db.profile.red, self.db.profile.green, self.db.profile.blue, 1)
		a:SetBackdropBorderColor(self.db.profile.Bred, self.db.profile.Bgreen, self.db.profile.Bblue, 1)
		a:EnableMouse(true)
		
		a:SetScript("OnEnter", function()
			a:SetBackdropBorderColor(self.db.profile.Hred, self.db.profile.Hgreen, self.db.profile.Hblue, 1)
		end)
		a:SetScript("OnLeave", function()
			a:SetBackdropBorderColor(self.db.profile.Bred, self.db.profile.Bgreen, self.db.profile.Bblue, 1)
		end)
	
		a:Show()
		
		table.insert(storage, a)
	end
	
	return storage
end

function MobileVault:ToggleFrame()
	if self.anchor:IsVisible() then
		self.anchor:Hide()
	else
		if not self.setup then
			self:SetupImageFrame()
			self.setup = true
		end
		self:SetupDBTables()
		if self.db.realm.guilds[self.GuildName].hasData then
			self:Unpopulate()
			self:Populate()
		end
		self.anchor:Show()
	end
end
